%global namedreltag .Final
%global namedversion %{version}%{?namedreltag}

Name:             jboss-jts
Version:          4.16.2
Release:          1%{?dist}
Summary:          TBD
Group:            Development/Libraries
License:          LGPLv2+
URL:              https://community.jboss.org/wiki/JBossJTS

# svn export http://anonsvn.jboss.org/repos/labs/labs/jbosstm/tags/JBOSSTS_4_16_2_Final/ jboss-jts-4.16.2.Final
# find jboss-jts-4.16.2.Final -name '*.jar' -delete
# tar cafJ jboss-jts-4.16.2.Final.tar.xz jboss-jts-4.16.2.Final
Source0:          jboss-jts-%{namedversion}.tar.xz

Source1:          https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/jbossts/jbossjta/%{namedversion}/jbossjta-%{namedversion}.pom
Source2:          https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/jbossts/jbossjta-integration/%{namedversion}/jbossjta-integration-%{namedversion}.pom 

# Patched Ant xml files
# Removed com.arjuna.ats.jta.distributed.SimpleIsolatedServers test
# Removed some tests as they fail with Byteman
Patch0:           %{name}-%{namedversion}-build.patch
# Added support for JBoss publican style shipped in Fedora
Patch1:           %{name}-%{namedversion}-publican.patch
# Removed ArjunaCore/arjuna/classes/com/arjuna/ats/arjuna/tools/stats/TxPerfGraph.java because we don't have orson packaged
Patch2:           %{name}-%{namedversion}-orson.patch
# Removed ArjunaCore/arjuna/classes/com/arjuna/ats/internal/arjuna/objectstore/hornetq/* classes because we don't have hornetq
Patch3:           %{name}-%{namedversion}-hornetq.patch
# Patch to remove hornetq dependency from the pom (SOURCE0)
Patch4:           %{name}-%{namedversion}-pom.patch
# Patch to remove hornetq dependency from the integration pom (SOURCE1)
Patch5:           %{name}-%{namedversion}-integration-pom.patch

BuildArch:        noarch

BuildRequires:    jpackage-utils
BuildRequires:    java-devel
BuildRequires:    junit
BuildRequires:    ant
BuildRequires:    ant-junit
BuildRequires:    ant-contrib
BuildRequires:    emma
BuildRequires:    byteman
BuildRequires:    jboss-logging
BuildRequires:    jboss-logging-tools
BuildRequires:    jboss-connector-1.6-api
BuildRequires:    jboss-transaction-1.1-api
BuildRequires:    jboss-transaction-spi
BuildRequires:    jfreechart
BuildRequires:    publican-jboss
BuildRequires:    java-service-wrapper

Requires:         jpackage-utils
Requires:         java
Requires:         byteman
Requires:         emma
Requires:         jboss-logging
Requires:         jboss-logging-tools
Requires:         jboss-connector-1.6-api
Requires:         jboss-transaction-1.1-api
Requires:         jboss-transaction-spi
Requires:         jfreechart
Requires:         java-service-wrapper

# TODO: add docs or manual subpackage with all pdfs - currently disabled in build patch

%description
TBD

%package javadoc
Summary:          Javadocs for %{name}
Group:            Documentation
Requires:         jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n jboss-jts-%{namedversion}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

# Most probably this should go into different place
cp %{SOURCE1} jbossjta.pom
cp %{SOURCE2} jbossjta-integration.pom

%patch4 -p0
%patch5 -p0

%build

mkdir -p  common/lib/ext
mkdir -p  build/extlib

ln -s $(build-classpath junit) common/lib/ext/junit.jar

ln -s $(build-classpath junit) ext/junit.jar
ln -s $(build-classpath emma) ext/emma.jar
ln -s $(build-classpath emma_ant) ext/emma_ant.jar
ln -s $(build-classpath jboss/jboss-logging) ext/jboss-logging.jar
ln -s $(build-classpath jboss-logging-processor) ext/jboss-logging-processor.jar
#ln -s $(build-classpath jboss/jboss-logging-generator) ext/jboss-logging-generator.jar
# This is not ironjacamar, but it seems it provides required classes
ln -s $(build-classpath jboss/jboss-connector-1.6-api) ext/ironjacamar-spec-api.jar
ln -s $(build-classpath jboss/jboss-transaction-1.1-api) ext/jboss-transaction-api_1.1_spec.jar

ln -s $(build-classpath byteman/byteman) ext/byteman.jar
ln -s $(build-classpath byteman/byteman-bmunit) ext/byteman-bmunit.jar
ln -s $(build-classpath byteman/byteman-dtest) ext/byteman-dtest.jar
ln -s $(build-classpath byteman/byteman-install) ext/byteman-install.jar
ln -s $(build-classpath byteman/byteman-submit) ext/byteman-submit.jar

ln -s $(build-classpath jboss-transaction-spi) ext/jboss-transaction-spi.jar

# This doesn't look good
ln -s %{_libdir}/java-service-wrapper/wrapper.jar ext/wrapper.jar

# Uhlalala
ln -s $(build-classpath jfreechart/jfreechart) ext/jfreechart-1.0.6.jar

ant jbossjta

%install
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_mavenpomdir}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# JAR
install -pm 644 install/lib/jbossjta.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjta.jar
install -pm 644 install/lib/jbossjta-integration.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjta-integration.jar
# No POM's for these files:
install -pm 644 install/services/lib/jbossjta-services.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjta-services.jar

# POM
install -pm 644 jbossjta.pom $RPM_BUILD_ROOT%{_mavenpomdir}/JPP.%{name}-jbossjta.pom
install -pm 644 jbossjta-integration.pom $RPM_BUILD_ROOT%{_mavenpomdir}/JPP.%{name}-jbossjta-integration.pom

# DEPMAP
%add_maven_depmap JPP.%{name}-jbossjta.pom %{name}/jbossjta.jar
%add_maven_depmap JPP.%{name}-jbossjta-integration.pom %{name}/jbossjta-integration.jar

# APIDOCS
cp -rp install/htdocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%files
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%{_javadir}/*

%files javadoc
%{_javadocdir}/%{name}

%changelog
* Mon Nov 21 2011 Marek Goldmann <mgoldman@redhat.com> 4.16.12-1
- Initial packaging

